#ifndef NETWORKLIB_ROUTER_POSITION_H
#define NETWORKLIB_ROUTER_POSITION_H

class RouterPosition : public NetworkObject {
	public:
		RouterPosition()									{ x=y=0; }
		RouterPosition( const RouterPosition & other )		{ x=other.x; y=other.y; }
		RouterPosition( int x_, int y_ )					{ x=x_; y=y_; }

		void Set( int x_ , int y_ )							{ x=x_; y=y_; } 
		int X() const										{ return x; }
		int Y() const										{ return y; }

		bool operator==( const RouterPosition & other ) const 
					{ return x==other.x && y==other.y; }

		bool operator!=( const RouterPosition & other ) const 
					{ return x!=other.x || y!=other.y; }

		const RouterPosition & operator=( const RouterPosition & other )  
					{ x=other.x; y=other.y; return *this; }
	private:
		int x;
		int y; 
};

#endif // NETWORKLIB_ROUTER_POSITION_H
